/*
DELx0D Version 1.01
Copyright 2016 Sogaya
Removing carriage-return characters from the file.

WATCOM

*/

#define VERSION 1.01
#define DEL_0D_TEXT "DELx0D.txt"
#define FILE_NAME_SIZE 256
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

void guide(void);

int main(int argc, char *argv[]) {
    char *buffer;
    char *p;
    char file_name[FILE_NAME_SIZE];
    char new_file[FILE_NAME_SIZE];
    FILE *binary;
    FILE *file;
    int k;
    int m = 0;
    long size;

    switch(argc) {
    case 2:
        if(! strcmp(argv[1], "-V") ) {
            guide();
            return 1;
        }

        strcpy(file_name, argv[1]);
        strcpy(new_file, DEL_0D_TEXT); /* DELx0D produces DEL_0D_TEXT. */
        break;
    case 3:
        strcpy(file_name, argv[1]);
        strcpy(new_file, argv[2]);
        break;
    default:
        guide();
        return 1;
    }

    file = fopen(file_name, "rb");
    if(file == NULL) {
        fprintf(stderr, "%s\n", file_name);
        return 1;
    }

/* Measuring file size to allocate memory */
    fseek(file, 0L, SEEK_END);
    size = ftell(file);
    p = malloc(size);
    if(p == NULL) {
        fprintf(stderr, "p = malloc(size)\n%d bytes", size);
        return 1;
    }

    buffer = malloc(size);
    if(buffer == NULL) {
        fprintf(stderr, "buffer = malloc(size)\n%d bytes", size);
        return 1;
    }

/* Setting the pointer to the beginning of file */
    fseek(file, 0L, SEEK_SET);
    binary = fopen(new_file, "wb");
    if(binary == NULL) {
        fprintf(stderr, "%s\n", new_file);
        return 1;
    }

    fread(p, 1, size, file);
    for(k = 0; k < size; k++) {
        switch(p[k]) {
        case 0x0D:
            continue; /* 0Dh has been removed. */
        default:
            buffer[m++] = p[k];
            break;
        }

    }

    fwrite(buffer, m, 1, binary);
    fclose(file);
    fclose(binary);
    free(buffer);
    free(p);
    return 0;
}

void guide(void) {
    fprintf(stderr, "DELx0D Version %1.3f\n", VERSION);
    fprintf(stderr, "\n");
    fprintf(stderr, "DELx0D -V \n");
    fprintf(stderr, "DELx0D file_name # Produce DELx0D.txt \n");
    fprintf(stderr, "DELx0D file_name new_file\n");
}
