package info.lotosummary.software;
import net.goui.util.MTRandom;

public class MT extends PRNG {
    static final int KEY_LENGTH = 4;
    static final int NOT_CONVERTED = -1;
    static final long TEN_DIGITS = 1000000000L;

    MTRandom mt;
    String error;

    public MT(long seed) {
        int[] init = new int[KEY_LENGTH];
        long full_seed;

        if(seed < TEN_DIGITS) {
            full_seed = seed + TEN_DIGITS; // 1000123456, for example.
        } else {
            full_seed = seed;
        }

        String g = String.valueOf(full_seed);
/*
0123456789
1339415048
    415   
     150  
      504 
       048
*/
        String s0 = g.substring(4, 7);
        init[0] = stringToInteger(s0);
        String s1 = g.substring(5, 8);
        init[1] = stringToInteger(s1);
        String s2 = g.substring(6, 9);
        init[2] = stringToInteger(s2);
        String s3 = g.substring(7, 10);
        init[3] = stringToInteger(s3);
        mt = new MTRandom(init);
    }

    private int stringToInteger(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e1) {
            error = "NumberFormatException e1";
            return NOT_CONVERTED;
        }

    }

    public int nextRandom() {
        return mt.nextInt();
    }

}
